package com.stupidbeauty.libexist.scanningexample.activity;

import android.app.Activity;
import android.os.Bundle;
import android.widget.Button;
import android.widget.LinearLayout;

import com.stupidbeauty.exist.ExistMessageContainer;
import com.stupidbeauty.exist.ServiceDiscoveredListener;
import com.stupidbeauty.exist.ServicePublisher;
import com.stupidbeauty.libexist.scanningexample.R;

import java.net.InetAddress;
import java.util.HashSet;
import java.util.Set;
import butterknife.Bind;
import butterknife.ButterKnife;

public class ScanActivity extends Activity implements ServiceDiscoveredListener
{
	@SuppressWarnings({"WeakerAccess", "unused"})
	@Bind(R.id.servicesList)
	LinearLayout servicesList; //!<服务列表布局。
	private final Set<String> serviceStringSet=new HashSet<>(); //!<服务字符串集合。

	@Override
	public void onServiceDiscovered(ExistMessageContainer.ExistMessage videoStreamQueryResponseMessage, InetAddress senderAddress) {
		String ip=senderAddress.getHostAddress(); //IP。
		int port=videoStreamQueryResponseMessage.getServicePublishMessage().getPort(); //获取端口号。
		String serviceName=videoStreamQueryResponseMessage.getServicePublishMessage().getName(); //获取服务名字。

		String wholeString=ip+"/"+port+"/"+serviceName; //构造完整字符串。

		//noinspection StatementWithEmptyBody
		if (serviceStringSet.contains(wholeString)) //之前已经发现。
		{

		} //if (serviceStringSet.contains(wholeString)) //之前已经发现。
		else //之前尚未发现。
		{
			serviceStringSet.add(wholeString); //加入到集合中。

			showNewService(wholeString); //显示新发现的服务。
		} //else //之前尚未发现。
	}

	private void 		showNewService(final String wholeString) //显示新发现的服务。
	{
		runOnUiThread(
				new Runnable()
				{
					@Override
					public void run()
					{
						Button serviceButton=new Button(ScanActivity.this); //创建按钮。

						serviceButton.setText(wholeString); //设置文字。

						servicesList.addView(serviceButton); //添加到界面中。

					}
				});


	} //private void 		showNewService(String wholeString)

	/**scan_activity 活动被创建*/
	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.scan_activity);

		ButterKnife.bind(this); //绑定视图。

		startScanningService(); //开始发布服务。
	} //protected void onCreate(Bundle savedInstanceState)

	/**
	 * 开始发布服务。
	 */
	private void startScanningService()
	{
		ServicePublisher servicePublisher=new ServicePublisher(this); //创建一个发布器。

		servicePublisher.setServiceDiscoveredListener(this); //设置监听器，发现了服务。


		servicePublisher.startScanning(); //开始扫描。
	} //private void startScanningService()
}
